# coding: utf-8

"""
    Pieces Isomorphic OpenAPI

    Endpoints for Assets, Formats, Users, Asset, Format, User.

    The version of the OpenAPI document: 1.0
    Contact: tsavo@pieces.app
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class Auth0Redirects(BaseModel):
    """
    The redirect URI for you Auth 0 Service  # noqa: E501
    """
    authenticated: Optional[StrictStr] = Field(None, description="Where the Auth0 redirects after the user is authorized")
    unauthenticated: Optional[StrictStr] = Field(None, description="The redirect where a user returns once unauthenticated")
    __properties = ["authenticated", "unauthenticated"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Auth0Redirects:
        """Create an instance of Auth0Redirects from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Auth0Redirects:
        """Create an instance of Auth0Redirects from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Auth0Redirects.parse_obj(obj)

        _obj = Auth0Redirects.parse_obj({
            "authenticated": obj.get("authenticated"),
            "unauthenticated": obj.get("unauthenticated")
        })
        return _obj


