# coding: utf-8

"""
    Pieces Isomorphic OpenAPI

    Endpoints for Assets, Formats, Users, Asset, Format, User.

    The version of the OpenAPI document: 1.0
    Contact: tsavo@pieces.app
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from pieces_client.models.embedded_model_schema import EmbeddedModelSchema
from pieces_client.models.graphical_ocr_descriptive_statistics_confidence import GraphicalOCRDescriptiveStatisticsConfidence

class GraphicalOCRDescriptiveStatistics(BaseModel):
    """
    Model for monitoring and evaluating the OCR feature  # noqa: E501
    """
    var_schema: Optional[EmbeddedModelSchema] = Field(None, alias="schema")
    asset: StrictStr = Field(...)
    user: StrictStr = Field(...)
    model: StrictStr = Field(...)
    created: StrictStr = Field(...)
    os: StrictStr = Field(...)
    confidence: GraphicalOCRDescriptiveStatisticsConfidence = Field(...)
    duration: StrictStr = Field(...)
    __properties = ["schema", "asset", "user", "model", "created", "os", "confidence", "duration"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GraphicalOCRDescriptiveStatistics:
        """Create an instance of GraphicalOCRDescriptiveStatistics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of var_schema
        if self.var_schema:
            _dict['schema'] = self.var_schema.to_dict()
        # override the default output from pydantic by calling `to_dict()` of confidence
        if self.confidence:
            _dict['confidence'] = self.confidence.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GraphicalOCRDescriptiveStatistics:
        """Create an instance of GraphicalOCRDescriptiveStatistics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GraphicalOCRDescriptiveStatistics.parse_obj(obj)

        _obj = GraphicalOCRDescriptiveStatistics.parse_obj({
            "var_schema": EmbeddedModelSchema.from_dict(obj.get("schema")) if obj.get("schema") is not None else None,
            "asset": obj.get("asset"),
            "user": obj.get("user"),
            "model": obj.get("model"),
            "created": obj.get("created"),
            "os": obj.get("os"),
            "confidence": GraphicalOCRDescriptiveStatisticsConfidence.from_dict(obj.get("confidence")) if obj.get("confidence") is not None else None,
            "duration": obj.get("duration")
        })
        return _obj


