# coding: utf-8

"""
    Pieces Isomorphic OpenAPI

    Endpoints for Assets, Formats, Users, Asset, Format, User.

    The version of the OpenAPI document: 1.0
    Contact: tsavo@pieces.app
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field
from pieces_client.models.classification_generic_enum import ClassificationGenericEnum
from pieces_client.models.classification_specific_enum import ClassificationSpecificEnum
from pieces_client.models.embedded_model_schema import EmbeddedModelSchema
from pieces_client.models.fragment_format import FragmentFormat

class SegmentedTechnicalLanguageFragment(BaseModel):
    """
    This is the output iterable model for '/machine_learning/text/technical_language/parsers/segmentation'  specific is optional here, however you can pass in classify: true to get the specific classificaiton in the case the generic is code.  # noqa: E501
    """
    var_schema: Optional[EmbeddedModelSchema] = Field(None, alias="schema")
    generic: ClassificationGenericEnum = Field(...)
    specific: Optional[ClassificationSpecificEnum] = None
    fragment: FragmentFormat = Field(...)
    __properties = ["schema", "generic", "specific", "fragment"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SegmentedTechnicalLanguageFragment:
        """Create an instance of SegmentedTechnicalLanguageFragment from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of var_schema
        if self.var_schema:
            _dict['schema'] = self.var_schema.to_dict()
        # override the default output from pydantic by calling `to_dict()` of fragment
        if self.fragment:
            _dict['fragment'] = self.fragment.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SegmentedTechnicalLanguageFragment:
        """Create an instance of SegmentedTechnicalLanguageFragment from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SegmentedTechnicalLanguageFragment.parse_obj(obj)

        _obj = SegmentedTechnicalLanguageFragment.parse_obj({
            "var_schema": EmbeddedModelSchema.from_dict(obj.get("schema")) if obj.get("schema") is not None else None,
            "generic": obj.get("generic"),
            "specific": obj.get("specific"),
            "fragment": FragmentFormat.from_dict(obj.get("fragment")) if obj.get("fragment") is not None else None
        })
        return _obj


