# coding: utf-8

"""
    Pieces Isomorphic OpenAPI

    Endpoints for Assets, Formats, Users, Asset, Format, User.

    The version of the OpenAPI document: 1.0
    Contact: tsavo@pieces.app
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from pieces_client.models.classification import Classification
from pieces_client.models.embedded_model_schema import EmbeddedModelSchema
from pieces_client.models.role import Role

class TrackedFormat(BaseModel):
    """
    A minimal format to send to Mixpanel  # noqa: E501
    """
    var_schema: Optional[EmbeddedModelSchema] = Field(None, alias="schema")
    id: StrictStr = Field(..., description="The UUID of the format")
    classification: Classification = Field(...)
    role: Role = Field(...)
    asset: StrictStr = Field(..., description="The UUID of the asset associated")
    fragment: StrictBool = Field(...)
    file: StrictBool = Field(...)
    __properties = ["schema", "id", "classification", "role", "asset", "fragment", "file"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TrackedFormat:
        """Create an instance of TrackedFormat from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of var_schema
        if self.var_schema:
            _dict['schema'] = self.var_schema.to_dict()
        # override the default output from pydantic by calling `to_dict()` of classification
        if self.classification:
            _dict['classification'] = self.classification.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TrackedFormat:
        """Create an instance of TrackedFormat from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TrackedFormat.parse_obj(obj)

        _obj = TrackedFormat.parse_obj({
            "var_schema": EmbeddedModelSchema.from_dict(obj.get("schema")) if obj.get("schema") is not None else None,
            "id": obj.get("id"),
            "classification": Classification.from_dict(obj.get("classification")) if obj.get("classification") is not None else None,
            "role": obj.get("role"),
            "asset": obj.get("asset"),
            "fragment": obj.get("fragment"),
            "file": obj.get("file")
        })
        return _obj


